<!DOCTYPE html>
<html lang="en">
<head>
     <meta charset="UTF-8">
     <meta http-equiv="X-UA-Compatible" content="IE=edge">
     <meta name="viewport" content="width=device-width, initial-scale=1.0">
     <title>Task 35.10</title>
     
     <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
     <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
     <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>
<body>
     <div class="container-fluid">
          <div class="row">
               <div class="col-12">
                    <h2 class="text-center p-2">DANH SÁCH NGƯỜI DÙNG</h2>
               </div>
          </div>
          <div class="container-fluid">
               <div class="row form-group">
                    <div class="col-sm-12 text-nowrap">
                         <table class="table table-bordered table-striped table-hover" id="table-users">
                              <thead class="text-white thead-dark">
                                   <tr class="text-center">
                                        <th scope="col">STT</th>
                                        <th scope="col">Name</th>
                                        <th scope="col">Username</th>
                                        <th scope="col">Email</th>
                                        <th scope="col">Address</th>
                                        <th scope="col">Zip code</th>
                                        <th scope="col">Phone</th>
                                        <th scope="col">Company</th>
                                        <th scope="col">Action</th>
                                   </tr>
                              </thead>
                              <tbody></tbody>
                         </table>
                    </div>
               </div>
          </div>
     </div>
</body>
<script>
      "use strict";

     /*** REGION 1 - Global variables - Vùng khai báo hằng số, tham số TOÀN CỤC */

     /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
     $(document).ready(function(){
          onPageLoading();
     })
     /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
     //hàm xử lý viêc tải trang 
     function onPageLoading(){
          //B1: thu thâp dữ liêu

          //B2: Kiểm tra dữ liêu

          //B3: goi Sever
          $.ajax({
               url: "https://jsonplaceholder.typicode.com/users/", 
               type: "GET", 
               dataType: "json", 
               success: function(response){
                    console.log(response);

                    //B4: xử lý hiển thi
                    showAllDataToTableUSer(response);
               },
               error: function(ajaxContext){
                    alert(ajaxContext.responseText);
               } 
          })
          

     }
     /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
     //hàm xử lý viêc hiển thi thông tin lên bảng 
     function showAllDataToTableUSer(paramArray){

          for(var bI = 0; bI < paramArray.length; bI++){
              //tao row
              var bNewRow = $("<tr>").appendTo($("#table-users tbody"));

               //tao cell
               $("<td>").html(paramArray[bI].id).appendTo(bNewRow);
               $("<td>").html(paramArray[bI].name).appendTo(bNewRow);
               $("<td>").html(paramArray[bI].username).appendTo(bNewRow);
               $("<td>").html(paramArray[bI].email).appendTo(bNewRow);
               $("<td>").html(paramArray[bI].address.suite + ", " + paramArray[bI].address.street + ", " + paramArray[bI].address.city).appendTo(bNewRow);
               $("<td>").html(paramArray[bI].address.zipcode).appendTo(bNewRow);
               $("<td>").html(paramArray[bI].phone).appendTo(bNewRow);
               $("<td>").html(paramArray[bI].company.name).appendTo(bNewRow);

               //xử lý côt action có nút 
               var bColAction = $("<td>").addClass("btn-group").appendTo(bNewRow);//cột action
               
               //nút chi tiết 
               var bDetailAction = $("<button>", {html: "Chi tiết"})
                    .addClass("btn btn-info")
                    .data("id", paramArray[bI].id)
                    .appendTo(bColAction);
               //thêm sự kiện cho nút 
               bDetailAction.click(onDetailButtonClick);
               

          }
     }

     function onDetailButtonClick(paramBtn) {
      console.log("%c Nút chi tiết được ấn rồi nhé!!!", "color: red");

      var id = $(paramBtn.target).data("id"); // lấy giá trị của data-id
          console.log("ID: " + id);
     
     //goi và truyền data id qua form userdetail
     const vFORM_TO_OPEN = "userDetail.html";
     var vURLSiteToOpen = vFORM_TO_OPEN + "?" +"id=" + $(paramBtn.target).data("id");
     window.location.href = vURLSiteToOpen;
    }

</script>
</html>